%define device_mapper_version 1.02.21-1
 
Summary: Userland logical volume management tools 
Name: lvm2
Version: 2.02.27
Release: 2.el4
License: GPL
Group: System Environment/Base
URL: http://sources.redhat.com/lvm2
Source0: LVM2.%{version}.tgz
Patch0: lvm2-rhel4.patch
Patch1: lvm2-2_02_28-fix-cache-load.patch
Patch2: lvm2-2_02_28-fix-clvmd-rescan.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildRequires: device-mapper >= %{device_mapper_version}
BuildRequires: libselinux-devel
BuildRequires: libtermcap-devel
BuildRequires: ncurses-devel
BuildRequires: readline-devel
# Also requires kernel 2.6.9-24 to avoid some snapshot problems.
Requires: device-mapper >= %{device_mapper_version}
Requires(post): chkconfig
Requires(preun): chkconfig
Conflicts: lvm lvm2-cluster < %{version}
Obsoletes: lvm

%define _exec_prefix /usr

%description
LVM2 includes all of the support for handling read/write operations on
physical volumes (hard disks, RAID-Systems, magneto optical, etc.,
multiple devices (MD), see mdadd(8) or even loop devices, see
losetup(8)), creating volume groups (kind of virtual disks) from one
or more physical volumes and creating one or more logical volumes
(kind of logical partitions) in volume groups.

%prep
%setup -q -n LVM2.%{version}
%patch0 -p1 -b .rhel4
%patch1 -p1 -b .cache
%patch2 -p1 -b .clvmd

%build
%configure --enable-static_link --enable-readline --enable-lvm1_fallback --with-pool=internal --with-staticdir=/sbin --with-user= --with-group= --enable-dmeventd --enable-cmdlib
make DESTDIR=$RPM_BUILD_ROOT

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

ln -s lvm.static $RPM_BUILD_ROOT/sbin/lvm
ln -s lvm.static $RPM_BUILD_ROOT/sbin/pvscan
ln -s lvm.static $RPM_BUILD_ROOT/sbin/vgchange
ln -s lvm.static $RPM_BUILD_ROOT/sbin/vgscan
install -m 0700 -d $RPM_BUILD_ROOT/etc/lvm/archive
install -m 0700 -d $RPM_BUILD_ROOT/etc/lvm/backup
install -m 0700 -d $RPM_BUILD_ROOT/etc/lvm/cache
install -m 0700 -d $RPM_BUILD_ROOT/var/lock/lvm
install -m 0600 /dev/null $RPM_BUILD_ROOT/etc/lvm/cache/.cache

mkdir $RPM_BUILD_ROOT/%{_lib}
mv $RPM_BUILD_ROOT%{_libdir}/libdevmapper-event-lvm2mirror* $RPM_BUILD_ROOT/%{_lib}/

mkdir -p -m755 $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m 0755 scripts/lvm2_monitoring_init_rhel4 $RPM_BUILD_ROOT/etc/rc.d/init.d/lvm2-monitor

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig
/sbin/chkconfig --add lvm2-monitor
 
%postun
/sbin/ldconfig
if [ "$1" = 0 ]; then
	/sbin/chkconfig --del lvm2-monitor
fi

%files
%defattr(-,root,root,-)
%doc COPYING COPYING.LIB INSTALL README VERSION WHATS_NEW
/%{_lib}/libdevmapper-event-lvm2mirror.so*
/sbin/lvm.static
/sbin/lvm
/sbin/pvscan
/sbin/vgchange
/sbin/vgscan
%{_includedir}/lvm2cmd.h
%{_libdir}/liblvm2cmd.a*
%{_libdir}/liblvm2cmd.so*
%{_sbindir}/*
%{_mandir}/*/*
%dir /etc/lvm
%ghost /etc/lvm/cache/.cache
%config(noreplace) /etc/lvm/lvm.conf
%config /etc/rc.d/init.d/lvm2-monitor
/etc/lvm/backup
/etc/lvm/cache
/etc/lvm/archive
/var/lock/lvm

%changelog
* Fri Aug 24 2007 Zdenek Kabelac <zkabelac@redhat.com> - 2.02.27-2
- Introduce VG_GLOBAL lock type for vgscan/pvscan to trigger clvmd -R.
- Fix clvmd -R, so it fully refreshes the caches.
  Resolves: #138396

* Mon Jul 23 2007 Milan Broz <mbroz@redhat.com> - 2.02.27-1
- Add conflict with lvm2-cluster package from different update.
- Update to latest upstream release.
  Resolves: #180286 #199618 #202885 #203037 #231187 #233123
            #237689 #238487 #239779 #239781 #247444 #248449
            #234670 #248015

* Fri Jul 20 2007 Milan Broz <mbroz@redhat.com> - 2.02.21-6
- Fix invalid errors in lvm2-monitor initscript
  Resolves: #239779

* Mon Mar 26 2007 Milan Broz <mbroz@redhat.com> - 2.02.21-5
- Fix creation and conversion of tagged mirrors.
- Resolves: rhbz#229471

* Mon Mar 19 2007 Milan Broz <mbroz@redhat.com> - 2.02.21-4
- Fix processing of exit status in init scripts.
- Fix reading of striped LVs in LVM1 format.
- Flag nolocking as clustered so clvmd startup sees clustered LVs.
- Resolves: rhbz#231979 rhbz#232397

* Fri Feb 02 2007 Milan Broz <mbroz@redhat.com> - 2.02.21-3
- Build against latest device-mapper package

* Tue Jan 30 2007 Alasdair Kergon <agk@redhat.com> - 2.02.21-1
- Add warning to lvm2_monitoring_init_rhel4 if attempting to stop monitoring.
- Fix vgsplit to handle mirrors.
- Reorder fields in reporting field definitions.
- Fix vgs to treat args as VGs even when PV fields are displayed.
- Fix md signature check to handle both endiannesses.

* Fri Jan 26 2007 Alasdair Kergon <agk@redhat.com> - 2.02.20-1
- Fix exit statuses of reporting tools.
- Update reporting man pages.
- Add --clustered to man pages.
- Add field definitions to report help text.
- Add devices/ignore_suspended_devices to ignore suspended dm devices.
- dmeventd mirror sets ignore_suspended_devices and avoids scanning mirrors.
- Add init script for dmeventd monitoring.
- lvm.static no longer interacts with dmeventd unless explicitly asked to.
- Fix refresh_toolcontext() always to wipe persistent device filter cache.

* Wed Jan 17 2007 Alasdair Kergon <agk@redhat.com> - 2.02.19-1
- Report dmeventd mirror monitoring status.
- Fix dmeventd mirror status line processing.
- Some libdevmapper-event interface changes.
- Fix a segfault if an empty config file section encountered.
- Fix cmdline PE range processing segfault (2.02.13).
- Fix partition table processing after sparc changes (2.02.16).
- Move basic reporting functions into libdevmapper.

* Thu Jan 11 2007 Alasdair Kergon <agk@redhat.com> - 2.02.18-1
- Revised libdevmapper-event interface for dmeventd.
- Prevent permission changes on active mirrors.
- Print warning instead of error message if lvconvert cannot zero volume.
- Add snapshot options to lvconvert man page.
- dumpconfig accepts a list of configuration variables to display.
- Change dumpconfig to use --file to redirect output to a file.
- Avoid vgreduce error when mirror code removes the log LV.
- Fix ambiguous vgsplit error message for split LV.
- Fix lvextend man page typo.
- Use no flush suspending for mirrors.
- Add dmeventd_mirror register_mutex, tidy initialisation & add memlock.
- Fix create mirror with name longer than 22 chars.
- Fix dmeventd mirror to cope if monitored device disappears.

* Thu Dec 14 2006 Alasdair Kergon <agk@redhat.com> - 2.02.17-1
- Add missing pvremove error message when device doesn't exist.
- When lvconvert allocates a mirror log, respect parallel area constraints.
- Check for failure to allocate just the mirror log.
- Support mirror log allocation when there is only one PV: area_count now 0.
- Fix detection of smallest area in _alloc_parallel_area() for cling policy.

* Fri Dec 01 2006 Alasdair Kergon <agk@redhat.com> - 2.02.16-1
- Fix VG clustered read locks to use PR not CR. 
- Adjust some alignments for ia64. 
- Fix mirror segment removal to use temporary error segment.

* Tue Nov 21 2006 Alasdair Kergon <agk@redhat.com> - 2.02.15-3
- Fix clvmd init script line truncation.

* Tue Nov 21 2006 Alasdair Kergon <agk@redhat.com> - 2.02.15-2
- Fix lvm.conf segfault.
 
* Mon Nov 20 2006 Alasdair Kergon <agk@redhat.com> - 2.02.15-1
- Install lvmdump with man page.
- Fix check for snapshot module when activating snapshot.
- Fix pvremove error path for case when PV is in use.
- Warn if certain duplicate config file entries are seen (e.g. filters).
- Fix --autobackup argument which could never disable backups.

* Fri Nov 11 2006 Alasdair Kergon <agk@redhat.com> - 2.02.14-1.0
- Fix adjusted_mirror_region_size() to handle 64-bit size.
- Add some missing bounds checks on 32-bit extent counters.
- Add Petabyte and Exabyte support.
- Fix lvcreate error message when 0 extents requested.
- lvremove man page: volumes must be cluster inactive before being removed.
- Protect .cache manipulations with fcntl locking.
- Change .cache timestamp comparisons to use ctime.
- Fix mirror log LV writing to set all bits in whole LV.
- Fix clustered VG detection and default runlevels in clvmd_init_rhel4.
- Fix high-level free space check for partial allocations.

* Tue Oct 31 2006 Alasdair Kergon <agk@redhat.com> - 2.02.13-1.0
- Use dist variable for package release suffix.
- When adding snapshot leave cow LV mapped device active after zeroing.
- Add lvchange --resync.
- Perform high-level free space check before each allocation attempt.
- Don't allow a node to remove an LV that's exclusively active on anther node.
- Cope if same PV is included more than once in cmdline PE range list.
- Set PV size to current device size if it is found to be zero.
- Fix pvdisplay for non-orphans.
- Fall back to internal locking if external locking lib is missing or fails.
- Retain activation state after changing LV minor number with --force.
- Propagate clustered flag in vgsplit and require resizeable flag.

* Fri Oct 13 2006 Alasdair Kergon <agk@redhat.com> - 2.02.11-1.0
- Improve allocation policy for mirrors.
- Accept size as percentages in lvcreate and lvresize.
- Fix PE size calculations for small PEs.

* Tue Sep 19 2006 Alasdair Kergon <agk@redhat.com> - 2.02.10-1.0
- New upstream with fixes.

* Fri Jul 14 2006 Jon Brassow <jbrassow@redhat.com> -2.02.06-6.0
- Fixed bad pointer in target_registered.

* Tue Jul 11 2006 Alasdair Kergon <agk@redhat.com> - 2.02.06-5.0
- Fix monitoring shutdown when devire removed. (194125)
- Prevent renaming of clustered mirrors for now. (195610)

* Tue Jul 04 2006 Alasdair Kergon <agk@redhat.com> - 2.02.06-4.0
- Fix PV tools to include orphaned PVs in default output again. (195276)
- Avoid clvm 'unaligned access' error on some archs. (194626, lost)
- Fixes and workarounds for mirroring. (195476, 197268)

* Wed May 24 2006 Alasdair Kergon <agk@redhat.com> - 2.02.06-3.0
- Prevent snapshots of mirrors. (192032)

* Tue May 16 2006 Alasdair Kergon <agk@redhat.com> - 2.02.06-2.0
- Mirror lvcreate corelog fix. (191923)

* Fri May 12 2006 Alasdair Kergon <agk@redhat.com> - 2.02.06-1.0
- More fixes upstream.

* Wed Apr 26 2006 Alasdair Kergon <agk@redhat.com> - 2.02.05-1.0
- Latest upstream release.

* Wed Feb 8 2006 Alasdair Kergon <agk@redhat.com> - 2.02.02-1.0
- New upstream release including preview of mirroring support.

* Thu Jan 12 2006 Alasdair Kergon <agk@redhat.com> - 2.02.01-1.3
- Build against latest device-mapper package. (176877)

* Wed Jan 04 2006 Alasdair Kergon <agk@redhat.com> - 2.02.01-1.2
- Build against latest device-mapper package. (176877)

* Fri Dec 02 2005 Alasdair Kergon <agk@redhat.com> - 2.02.01-1.1
- Build against latest device-mapper package.

* Wed Nov 23 2005 Alasdair Kergon <agk@redhat.com> - 2.02.01-1.0
- Fix lvdisplay command line for snapshots; fix open file promotion
  to read/write; fix an lvcreate error path.
- Update package dependencies.

* Thu Nov 10 2005 Alasdair Kergon <agk@redhat.com> - 2.02.00-1.0
- Lots of fixes and new activation code.

* Fri Sep 1 2005 Alasdair Kergon <agk@redhat.com> - 2.01.14-2.0
- Suppress unnecessary fsync error message. [165709]

* Thu Aug 4 2005 Alasdair Kergon <agk@redhat.com> - 2.01.14-1.0
- Some bug fixes for recent release.

* Wed Jul 13 2005 Alasdair Kergon <agk@redhat.com> - 2.01.13-1.0
- Update to latest upstream release.

* Tue Mar 22 2005 Alasdair Kergon <agk@redhat.com> - 2.01.08-1.0
- Improve detection of external changes affecting internal cache.
- Add clustered VG attribute.
- Suppress rmdir opendir error message.

* Tue Mar 08 2005 Alasdair Kergon <agk@redhat.com> - 2.01.07-1.0
- Remove build directory from built-in path.
- Always obsolete lvm.

* Fri Mar 04 2005 Alasdair Kergon <agk@redhat.com> - 2.01.06-1.0
- Extra /dev scanning required for clustered operation.

* Fri Feb 18 2005 Alasdair Kergon <agk@redhat.com> - 2.01.05-1.0
- Reinstate /sbin lvm.static links, but invoke dynamic build if appropriate.

* Wed Feb 09 2005 Alasdair Kergon <agk@redhat.com> - 2.01.04-1.0
- Offset pool minors; lvm2cmd.so skips open fd check; pvmove -f gone.

* Tue Feb 01 2005 Alasdair Kergon <agk@redhat.com> - 2.01.03-1.0
- Fix snapshot device size & 64-bit display output.

* Fri Jan 21 2005 Alasdair Kergon <agk@redhat.com> - 2.01.02-1.0
- Minor fixes.

* Mon Jan 17 2005 Alasdair Kergon <agk@redhat.com> - 2.01.01-1.0
- Update vgcreate man page.  Preparation for snapshot origin extension fix.

* Mon Jan 17 2005 Alasdair Kergon <agk@redhat.com> - 2.01.00-1.0
- Fix metadata auto-correction. Only request open_count when needed.

* Wed Jan 12 2005 Tim Waugh <twaugh@redhat.com> - 2.00.33-2.0
- Rebuilt for new readline.

* Fri Jan 7 2005 Alasdair Kergon <agk@redhat.com> - 2.00.33-1.0
- pvcreate wipes ext label
- several clvm fixes

* Thu Jan 6 2005 Alasdair Kergon <agk@redhat.com> - 2.00.32-2.0
- Remove temporary /sbin symlinks no longer needed.
- Include read-only pool support in the build.

* Wed Dec 22 2004 Alasdair Kergon <agk@redhat.com> - 2.00.32-1.0
- More fixes (143501).

* Sun Dec 12 2004 Alasdair Kergon <agk@redhat.com> - 2.00.31-1.0
- Fix pvcreate install issues.

* Fri Dec 10 2004 Alasdair Kergon <agk@redhat.com> - 2.00.30-1.0
- Additional debugging code.
- Some trivial man page corrections.

* Tue Nov 30 2004 Alasdair Kergon <agk@redhat.com> - 2.00.29-1.3
- Reinstate all archs.

* Sun Nov 28 2004 Alasdair Kergon <agk@redhat.com> - 2.00.29-1.2
- Try excluding more archs.

* Sat Nov 27 2004 Alasdair Kergon <agk@redhat.com> - 2.00.29-1.1
- Exclude s390x which fails.

* Sat Nov 27 2004 Alasdair Kergon <agk@redhat.com> - 2.00.29-1
- Fix last fix.

* Sat Nov 27 2004 Alasdair Kergon <agk@redhat.com> - 2.00.28-1
- Endian fix to partition/md signature detection.

* Wed Nov 24 2004 Alasdair Kergon <agk@redhat.com> - 2.00.27-1
- Fix partition table detection & an out of memory segfault.

* Tue Nov 23 2004 Alasdair Kergon <agk@redhat.com> - 2.00.26-1
- Several installation-related fixes & man page updates.

* Mon Oct 25 2004 Elliot Lee <sopwith@redhat.com> - 2.00.25-1.01
- Fix 2.6 kernel requirement

* Wed Sep 29 2004 Alasdair Kergon <agk@redhat.com> - 2.00.25-1
- Fix vgmknodes return code & vgremove locking.

* Fri Sep 17 2004 Alasdair Kergon <agk@redhat.com> - 2.00.24-2
- Obsolete old lvm1 packages; refuse install if running kernel 2.4. [bz 128185]

* Thu Sep 16 2004 Alasdair Kergon <agk@redhat.com> - 2.00.24-1
- More upstream fixes.  (Always check WHATS_NEW file for details.)
- Add requested BuildRequires. [bz 124916, 132408]

* Wed Sep 15 2004 Alasdair Kergon <agk@redhat.com> - 2.00.23-1
- Various minor upstream fixes.

* Thu Sep  3 2004 Alasdair Kergon <agk@redhat.com> - 2.00.22-1
- Permission fix included upstream; use different endian conversion macros.

* Thu Sep  2 2004 Jeremy Katz <katzj@redhat.com> - 2.00.21-2
- fix permissions on vg dirs

* Thu Aug 19 2004 Alasdair Kergon <agk@redhat.com> - 2.00.21-1
- New upstream release incorporating fixes plus minor enhancements.

* Tue Aug 17 2004 Jeremy Katz <katzj@redhat.com> - 2.00.20-2
- add patch for iSeries viodasd support
- add patch to check file type using stat(2) if d_type == DT_UNKNOWN (#129674)

* Sat Jul 3 2004 Alasdair Kergon <agk@redhat.com> - 2.00.20-1
- New upstream release fixes 2.6 kernel device numbers.

* Tue Jun 29 2004 Alasdair Kergon <agk@redhat.com> - 2.00.19-1
- Latest upstream release.  Lots of changes (see WHATS_NEW).

* Tue Jun 15 2004 Elliot Lee <sopwith@redhat.com> - 2.00.15-5
- rebuilt

* Wed May 26 2004 Alasdair Kergon <agk@redhat.com> - 2.00.15-4
- clone %description from LVM rpm

* Wed May 26 2004 Alasdair Kergon <agk@redhat.com> - 2.00.15-3
- vgscan shouldn't return error status when no VGs present

* Thu May 06 2004 Warren Togami <wtogami@redhat.com> - 2.00.15-2
- i2o patch from Markus Lidel

* Tue Apr 20 2004 Bill Nottingham <notting@redhat.com> - 2.00.15-1.1
- handle disabled SELinux correctly, so that LVMs can be detected in a
  non-SELinux context
  
* Mon Apr 19 2004 Alasdair Kergon <agk@redhat.com> - 2.00.15-1
- Fix non-root build with current version of 'install'.

* Fri Apr 16 2004 Alasdair Kergon <agk@redhat.com> - 2.00.14-1
- Use 64-bit file offsets.

* Fri Apr 16 2004 Alasdair Kergon <agk@redhat.com> - 2.00.13-1
- Avoid scanning devices containing md superblocks.
- Integrate ENOTSUP patch.

* Thu Apr 15 2004 Jeremy Katz <katzj@redhat.com> - 2.00.12-4
- don't die if we get ENOTSUP setting selinux contexts

* Thu Apr 15 2004 Alasdair Kergon <agk@redhat.com> 2.00.12-3
- Add temporary pvscan symlink for LVM1 until mkinitrd gets updated.

* Wed Apr 14 2004 Alasdair Kergon <agk@redhat.com> 2.00.12-2
- Mark config file noreplace.

* Wed Apr 14 2004 Alasdair Kergon <agk@redhat.com> 2.00.12-1
- Install default /etc/lvm/lvm.conf.
- Move non-static binaries to /usr/sbin.
- Add temporary links in /sbin to lvm.static until rc.sysinit gets updated.

* Thu Apr 08 2004 Alasdair Kergon <agk@redhat.com> 2.00.11-1
- Fallback to using LVM1 tools when using a 2.4 kernel without device-mapper.

* Wed Apr 07 2004 Alasdair Kergon <agk@redhat.com> 2.00.10-2
- Install the full toolset, not just 'lvm'.

* Wed Apr 07 2004 Alasdair Kergon <agk@redhat.com> 2.00.10-1
- Update to version 2.00.10, which incorporates the RH-specific patches
  and includes various fixes and enhancements detailed in WHATS_NEW.

* Wed Mar 17 2004 Jeremy Katz <katzj@redhat.com> 2.00.08-5
- Fix sysfs patch to find sysfs
- Take patch from dwalsh and tweak a little for setting SELinux contexts on
  device node creation and also do it on the symlink creation.  
  Part of this should probably be pushed down to device-mapper instead

* Thu Feb 19 2004 Stephen C. Tweedie <sct@redhat.com> 2.00.08-4
- Add sysfs filter patch
- Allow non-root users to build RPM

* Fri Feb 13 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Fri Dec  5 2003 Jeremy Katz <katzj@redhat.com> 2.00.08-2
- add static lvm binary

* Tue Dec  2 2003 Jeremy Katz <katzj@redhat.com> 
- Initial build.


